<?php
namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\Controller\CrudWithParameterBag;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DTO;
use Teknisa\MAN\Services;
use Teknisa\MAN\Utilities;

class LayoutProdCombinado extends CrudWithParameterBag {
    
    protected $dataSourceNameArray = array (
        'find' => 'vnd80400_layoutprodcombinado',
        'findGrupo' => 'vnd80400_layoutprodcombinado_grupo'
    );
    
    protected $parameterBagColumns = array (
        'findGrupo' => array('NRORG', 'CDFILIAL', 'NRCONFTELA'),
        'find' => array('NRORG', 'CDFILIAL')
    );
    
    public function __construct (Manager $dataSourceManager, ParameterBag $parameterBag, Utilities\Util $utilService, Services\LayoutProdCombinadoService $layoutService){
        $this->util = $utilService;
        $this->layout = $layoutService;
        parent::__construct($dataSourceManager, $parameterBag);
    }
    
    public function find(DTO\Request\Filter $request, DTO\Response $response){
        $this->dataSourceName = $this->dataSourceNameArray['find'];
        $this->parameterBagColumns = $this->parameterBagColumns['find'];
        parent::find($request, $response);
    }
    
    public function findGrupo(DTO\Request\Filter $request, DTO\Response $response){
        $this->dataSourceName = $this->dataSourceNameArray['findGrupo'];
        $this->parameterBagColumns = $this->parameterBagColumns['findGrupo'];
        parent::find($request, $response);
    }
    
    public function saveGrupo(DTO\Request $request, DTO\Response $response){
        $conditions = $this->util->getParamsAsArray($request)[0];
            
        if($conditions['__is_new'] == true){
        $params = array(
            ':DTINIVIGENCIA' => $conditions['DTINIVIGENCIA'],
            ':CDFILIAL'      => $conditions['CDFILIAL'],
            ':NRBUTTON'      => str_pad($conditions['NRBUTTON'],2,"0",STR_PAD_LEFT),
            ':DSBUTTON'      => $conditions['DSBUTTON'],
            ':NRLIMPRODCOM'  => $conditions['NRLIMPRODCOM'],
            ':NRCOLORBACK'   => $conditions['NRCOLORBACK'],
            ':NRCOLORTEXT'   => $conditions['NRCOLORTEXT'],
            ':NRCONFTELA'    => $conditions['NRCONFTELA'],
            ':IDTPBUTTON'    => 'B',
            ':NRPGCONFTELA'  => '1',
            ':IDTPBUTONAUX'  => '1',
            ':NRBUTTONAUX'   => '0',
            ':NRORG'         => $conditions['NRORG'],
            ':NRPGCONFTAUX'  => '1');
            $result[0] = $this->layout->saveBtn($params);
        }else{
            $params = array(
            ':DTINIVIGENCIA' => $conditions['DTINIVIGENCIA'],
            ':CDFILIAL'     => $conditions['CDFILIAL'],
            ':NRBUTTON'     => str_pad($conditions['NRBUTTON'],2,"0",STR_PAD_LEFT),
            ':DSBUTTON'     => $conditions['DSBUTTON'],
            ':NRLIMPRODCOM' => $conditions['NRLIMPRODCOM'],
            ':NRCOLORBACK'  => $conditions['NRCOLORBACK'],
            ':NRCONFTELA'   => $conditions['NRCONFTELA'],
            ':NRORG'        => $conditions['NRORG']);
            $result[0] = $this->layout->updateBtn($params);
        }
         $response->addDataSet(new DataSet('SaveGrupo', $result));
    }
    
    public function save(DTO\Request\DataSet $request, DTO\Response $response){
        $this->dataSourceName = $this->dataSourceNameArray['find'];
        parent::save($request, $response);
    }
    
     public function removeGrupo(DTO\Request $request, DTO\Response $response){
        $conditions = $this->util->getParamsAsArray($request);
        $params = array(
            ':CDFILIAL'     => $conditions['CDFILIAL'],
            ':NRCONFTELA'   => $conditions['NRCONFTELA'],
            ':NRBUTTON'     => $conditions['NRBUTTON'],
            ':NRORG'        => $conditions['NRORG'],
            ':DTINIVIGENCIA'=> $conditions['DTINIVIGENCIA']
        );
        $result = $this->layout->removeGrupo($params);
    }
    
    public function delete (DTO\Request\DataSet $request, DTO\Response $response){
        $this->dataSourceName = $this->dataSourceNameArray['findGrupo'];
        $this->parameterBagColumns = $this->parameterBagColumns['findGrupo'];
        parent::delete($request, $response);
    }
}