<?php

namespace Teknisa\MAN\Services;

use Teknisa\MAN\Utilities;

class ParaDeliveryService {
    
    protected $entityManager;
    
	public function __construct(\Doctrine\ORM\EntityManager $entityManager) {
        $this->entityManager = $entityManager;
    }
	
    public function deleteBlockedCard($NRORG, $NRSEQCARTAOBLOQ) {
		$params = array(
			':NRORG'           => $NRORG,
			':NRSEQCARTAOBLOQ' => $NRSEQCARTAOBLOQ
		);
		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::DELETE_BLOCKED_CARD, $params);
    }
    
    public function insertLojaDia($NRORG, $CDFILIAL, $CDLOJA, $NRDIAATENDELOJA, $HRINIATENDELOJA, $HRFIMATENDELOJA, $IDTPATENDELOJA, $NRSEQATENDELOJA, $DTINCLUSAO, $DTULTATU, $NRORGINCLUSAO, $CDOPERULTATU, $CDOPERINCLUSAO, $NRORGULTATU, $IDATENDELOJA) {
		$params = array(
			':NRORG'           => $NRORG,
			':CDFILIAL'        => $CDFILIAL,
			':CDLOJA'          => $CDLOJA, 
			':NRDIAATENDELOJA' => $NRDIAATENDELOJA,
			':HRINIATENDELOJA' => $HRINIATENDELOJA,
			':HRFIMATENDELOJA' => $HRFIMATENDELOJA,
			':IDTPATENDELOJA'  => $IDTPATENDELOJA,
			':NRSEQATENDELOJA' => $NRSEQATENDELOJA,
		    ':DTINCLUSAO'      => $DTINCLUSAO,
		    ':DTULTATU'        => $DTULTATU,
		    ':NRORGINCLUSAO'   => $NRORGINCLUSAO,
		    ':CDOPERULTATU'    => $CDOPERULTATU,
		    ':CDOPERINCLUSAO'  => $CDOPERINCLUSAO,
		    ':NRORGULTATU'     => $NRORGULTATU,
		    ':IDATENDELOJA'    => $IDATENDELOJA
		); 
		return $this->entityManager->getConnection()->executeQuery(self::INSERE_LOJA_DIA, $params);
    }
    
    public function verificaLojaDia($NRORG, $CDFILIAL, $CDLOJA, $NRDIAATENDELOJA, $HRINIATENDELOJA, $HRFIMATENDELOJA, $IDTPATENDELOJA, $NRSEQATENDELOJA) {
    	$params = array(
			':NRORG'           => $NRORG,
			':CDFILIAL'        => $CDFILIAL,
			':CDLOJA'          => $CDLOJA, 
			':NRDIAATENDELOJA' => $NRDIAATENDELOJA,
			':HRINIATENDELOJA' => $HRINIATENDELOJA,
			':HRFIMATENDELOJA' => $HRFIMATENDELOJA,
			':IDTPATENDELOJA'  => $IDTPATENDELOJA,
			':NRSEQATENDELOJA' => $NRSEQATENDELOJA
		);
		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::VERIFICA_LOJA_DIA, $params);
    }
    
    public function deleteLojaDia($NRORG, $CDFILIAL, $CDLOJA, $NRSEQATENDELOJA) {
		$params = array(
			':NRORG'           => $NRORG,
			':CDFILIAL'        => $CDFILIAL,
			':CDLOJA'          => $CDLOJA, 
			':NRSEQATENDELOJA' => $NRSEQATENDELOJA
		);
		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::DELETE_LOJA_DIA, $params);
    }
    
    public function deleteFilialAreaAtend($NRORG, $CDFILIAL, $CDAREA) {
		$params = array(
			':NRORG'           => $NRORG,
			':CDFILIAL'        => $CDFILIAL,
			':CDAREA'          => $CDAREA
		);
		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::DELETE_FILIAL_SERVICE_AREA, $params);
    }
    
    public function insertAreaAtend($row) {
		$params = array(
			':NRORG'     => $row['NRORG'],
			':CDAREA'    => $row['CDAREA'],
			':COORDAREA' => $row['COORDAREA'], 
			':NMAREA'    => $row['NMAREA'],
			':DSAREA'    => $row['DSAREA'],
			':DTINCLUSAO'      => $row['DTINCLUSAO'],
		    ':DTULTATU'        => $row['DTULTATU'],
		    ':NRORGINCLUSAO'   => $row['NRORGINCLUSAO'],
		    ':CDOPERULTATU'    => $row['CDOPERULTATU'],
		    ':CDOPERINCLUSAO'  => $row['CDOPERINCLUSAO'],
		    ':NRORGULTATU'     => $row['NRORGULTATU'],
		    ':HRINIATENDELOJA' => $row['HRINIATENDELOJA'],
		    ':HRFIMATENDELOJA' => $row['HRFIMATENDELOJA']
		);
		return $this->entityManager->getConnection()->executeQuery(self::INSERT_AREAATEND, $params);
    }
    
    public function updateAreaAtend($row) {
		$params = array(
			':NRORG'           => $row['NRORG'],
			':CDAREA'          => $row['CDAREA'],
			':COORDAREA'       => $row['COORDAREA'], 
			':NMAREA'          => $row['NMAREA'],
			':DSAREA'   	   => $row['DSAREA'],
		    ':DTULTATU'        => $row['DTULTATU'],
		    ':CDOPERULTATU'    => $row['CDOPERULTATU'],
		    ':NRORGULTATU'     => $row['NRORGULTATU'],
		    ':HRINIATENDELOJA' => $row['HRINIATENDELOJA'],
		    ':HRFIMATENDELOJA' => $row['HRFIMATENDELOJA']
		);
		return $this->entityManager->getConnection()->executeQuery(self::UPDATE_AREAATEND, $params);
    }
    
    public function deleteAreaAtend($NRORG, $CDAREA) {
		$params = array(
			':NRORG'           => $NRORG,
			':CDAREA'          => $CDAREA
		);
		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::DELETE_POLYGON, $params);
    }
    
    public function deleteHoraPromocao($NRORG, $NRDIAREGPROMO) {
		$params = array(
			':NRORG'           => $NRORG,
			':NRDIAREGPROM'    => $NRDIAREGPROMO
		);
		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::DELETE_HORAPROMOC, $params);
    }
    
    const UPDATE_AREAATEND = "
        UPDATE AREAATEND
        SET COORDAREA = :COORDAREA,
            NMAREA = :NMAREA,
            DSAREA = :DSAREA,
            DTULTATU = :DTULTATU,
            CDOPERULTATU = :CDOPERULTATU,
            NRORGULTATU = :NRORGULTATU,
            HRINIATENDELOJA = :HRINIATENDELOJA,
            HRFIMATENDELOJA = :HRFIMATENDELOJA
        WHERE CDAREA = :CDAREA AND NRORG = :NRORG
    ";
    
    const INSERT_AREAATEND = "
        INSERT INTO AREAATEND (CDAREA, COORDAREA, NMAREA, DSAREA, NRORG, 
        DTINCLUSAO, DTULTATU, NRORGINCLUSAO, CDOPERULTATU, CDOPERINCLUSAO, NRORGULTATU, HRFIMATENDELOJA, HRINIATENDELOJA)
        VALUES (:CDAREA, :COORDAREA, :NMAREA, :DSAREA, :NRORG, 
        :DTINCLUSAO, :DTULTATU, :NRORGINCLUSAO, :CDOPERULTATU, :CDOPERINCLUSAO, :NRORGULTATU, :HRFIMATENDELOJA, :HRINIATENDELOJA)
    ";
    
        
    const INSERE_LOJA_DIA = "
       INSERT INTO ATENDELOJA 
           (CDFILIAL, CDLOJA, NRDIAATENDELOJA, HRINIATENDELOJA, 
           HRFIMATENDELOJA, IDTPATENDELOJA, NRORG, NRSEQATENDELOJA, 
           DTINCLUSAO, DTULTATU, NRORGINCLUSAO, CDOPERULTATU, CDOPERINCLUSAO, NRORGULTATU, IDATENDELOJA)
        VALUES 
          (:CDFILIAL, :CDLOJA, :NRDIAATENDELOJA, :HRINIATENDELOJA, :HRFIMATENDELOJA,
           :IDTPATENDELOJA, :NRORG, :NRSEQATENDELOJA, 
           :DTINCLUSAO, :DTULTATU, :NRORGINCLUSAO, :CDOPERULTATU, :CDOPERINCLUSAO, :NRORGULTATU, :IDATENDELOJA)
    ";
    
    const INSERT_LEMBRETE_CEP = "
    	INSERT INTO LEMBRETEDLVCEP (CDLEMBRETE, NRCEP, DSMENSAGEM)
                      VALUES (:CDLEMBRETE, :NRCEP, :DSMENSAGEM)
    ";
    
    public function InsereLembreteCEP($CDLEMBRETE ,$NRCEP, $DSMENSAGEM) {
		$params = array(
			':CDLEMBRETE'           => $CDLEMBRETE,
			':NRCEP'           => $NRCEP,
			':DSMENSAGEM' => $DSMENSAGEM
		);
		return $this->entityManager->getConnection()->executeQuery(self::INSERT_LEMBRETE_CEP, $params);
    }
    
    const UPDATE_LEMBRETE_CEP = "
    	UPDATE LEMBRETEDLVCEP
    		SET NRCEP      = :NRCEP,
    			DSMENSAGEM = :DSMENSAGEM
    		WHERE CDLEMBRETE = :CDLEMBRETE
    ";
    
    public function UpdateLembreteCEP($CDLEMBRETE, $NRCEP, $DSMENSAGEM) {
		$params = array(
			':CDLEMBRETE' => $CDLEMBRETE,
			':NRCEP'      => $NRCEP,
			':DSMENSAGEM' => $DSMENSAGEM
		);
		
		return $this->entityManager->getConnection()->executeQuery(self::UPDATE_LEMBRETE_CEP, $params);
    }
    
    const BUSCAR_LEMBRETE_CEP_POR_CDLEMBRETE = "
    	SELECT CDLEMBRETE FROM LEMBRETEDLVCEP WHERE CDLEMBRETE = :CDLEMBRETE
    ";
    
    const BUSCAR_LEMBRETE_CEP_POR_NRCEP = "
    	SELECT NRCEP FROM LEMBRETEDLVCEP WHERE NRCEP = :NRCEP
    ";
    
    public function buscarLembreteCepPorNRCEP($NRCEP) {
		$params = array(
			':NRCEP'           => $NRCEP
		);
		return $this->entityManager->getConnection()->fetchAll(self::BUSCAR_LEMBRETE_CEP_POR_NRCEP, $params);
    }
    
    
    public function buscarLembreteCepPorCdLembrete($CDLEMBRETE) {
		$params = array(
			':CDLEMBRETE'           => $CDLEMBRETE
		);
		return $this->entityManager->getConnection()->fetchAll(self::BUSCAR_LEMBRETE_CEP_POR_CDLEMBRETE, $params);
    }
    
    const DELETE_LEMBRETE = "
        DELETE FROM LEMBRETEDLVCEP
         WHERE NRCEP = :NRCEP
         AND CDLEMBRETE = :CDLEMBRETE
    ";
    
    public function deleteLembrete($NRCEP, $CDLEMBRETE) {
		$params = array(
			':NRCEP'           => $NRCEP,
			':CDLEMBRETE'          => $CDLEMBRETE
		);
		return $this->entityManager->getConnection()->executeQuery(self::DELETE_LEMBRETE, $params);
    }
    
    const UPDATE_LEMBRETE = "
        UPDATE LEMBRETEDLVCEP
        SET DSMENSAGEM = :DSMENSAGEM
        WHERE 
        	NRCEP = :NRCEP 
        AND CDLEMBRETE = :CDLEMBRETE
    ";
    
    const UPDATE_DELIVERY_GERPARAMGERAL = "
        UPDATE GERPARAMGERAL
        SET IDUTILHRINICALLCENTER = :IDUTILHRINICALLCENTER
        WHERE NRORG = :NRORG
    ";
    
    const UPDATE_DELIVERY_PARAMGERAL = "
         UPDATE PARAMGERAL 
        	SET 
	        	IDMODODLV		= :IDMODODLV, 
	        	CDCLIENTE		= :CDCLIENTE, 
        		VRMINPEDIDO 	= :VRMINPEDIDO, 
	        	CDVENDEDORDLV	= :CDVENDEDORDLV, 
	        	CDLOJAESITEF	= :CDLOJAESITEF, 
	        	IDVALIDAATEN	= :IDVALIDAATEN
        	WHERE 
        		NRORG = :NRORG
    ";
    
    const READ_PARAMGERAL = "
         SELECT P.NRORG, P.IDMODODLV, CASE WHEN IDMODODLV = 'TOGO' THEN 'To GO' WHEN IDMODODLV = 'DELI' THEN 'Delivery' WHEN IDMODODLV = 'TODE' THEN 'Ambos' END AS NMMODDLV, P.CDCLIENTE, C.NMRAZSOCCLIE, V.NMRAZSOCVEN, P.VRMINPEDIDO, P.CDVENDEDORDLV, P.CDLOJAESITEF, P.IDVALIDAATEN, GP.IDUTILHRINICALLCENTER FROM PARAMGERAL P LEFT JOIN VENDEDOR V ON P.CDVENDEDORDLV = V.CDVENDEDOR LEFT JOIN CLIENTE C ON P.CDCLIENTE = C.CDCLIENTE LEFT JOIN GERPARAMGERAL GP ON P.CDPARGERAL = GP.CDPARGERAL WHERE P.NRORG = :NRORG
    ";
    
    public function updateDeliveyParamGeral($IDMODODLV, $CDCLIENTE, $VRMINPEDIDO, $CDVENDEDORDLV, $CDLOJAESITEF, $IDVALIDAATEN, $NRORG) {
		$params = array(
				':IDMODODLV'=> $IDMODODLV, 
	        	':CDCLIENTE'=> $CDCLIENTE, 
        		':VRMINPEDIDO'=> $VRMINPEDIDO, 
	        	':CDVENDEDORDLV'=> $CDVENDEDORDLV, 
	        	':CDLOJAESITEF'=> $CDLOJAESITEF, 
	        	':IDVALIDAATEN'=> $IDVALIDAATEN, 
	        	':NRORG'=> $NRORG
			);
		$this->entityManager->getConnection()->executeQuery(self::UPDATE_DELIVERY_PARAMGERAL, $params);
		
    }
    
    public function updateDeliveyGerParamGeral($IDUTILHRINICALLCENTER, $NRORG) {
		$params = array(
			':IDUTILHRINICALLCENTER'=> $IDUTILHRINICALLCENTER,
			':NRORG'=> $NRORG,
		);
		return $this->entityManager->getConnection()->executeQuery(self::UPDATE_DELIVERY_GERPARAMGERAL, $params);
    }
    
    }